//+------------------------------------------------------------------+
//|                                       CSynchronizedBufferRSI.mqh |
//|                                            Copyright 2010, Lizar |
//|                            https://login.mql5.com/ru/users/Lizar |
//|                                              Revision 2011.01.03 |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Class CSynchronizedBufferRSI                                     |
//| Appointment:            |
//|                RSI                            |
//+------------------------------------------------------------------+
class CSynchronizedBufferRSI
  {
   protected:
      string            m_symbol;      //    
      ENUM_TIMEFRAMES   m_period;      //     
      int               m_handle;      //  
      int               m_rsi_period;  //  
      int               m_rsi_count;   //    
      bool              m_init_flag;   //  
   public:
      double   buffer[];               //  

      //---    :
      void CSynchronizedBufferRSI();
      void ~CSynchronizedBufferRSI();
      //---  :
      bool Init(int n,string symbol,int rsi_count,int rsi_period);
      //---     :
      void RefreshBuffer();
      void Refresh(int bar=0);
      //---  /  :
      bool GetInit()   {return(m_init_flag);}
  };

//+------------------------------------------------------------------+
//|                                                 |
//| INPUT:  no.                                                      |
//| OUTPUT: no.                                                      |
//| REMARK: no.                                                      |
//+------------------------------------------------------------------+
void CSynchronizedBufferRSI::CSynchronizedBufferRSI()
  {
   m_init_flag=false;
   m_handle=INVALID_HANDLE;
   m_symbol=_Symbol;
   m_period=_Period;
  }
  
//+------------------------------------------------------------------+
//|                                                  |
//| INPUT:  no.                                                      |
//| OUTPUT: no.                                                      |
//| REMARK: no.                                                      |
//+------------------------------------------------------------------+
void CSynchronizedBufferRSI::~CSynchronizedBufferRSI()
  {
   //---     :
   if(m_handle!=INVALID_HANDLE) IndicatorRelease(m_handle);  
  }
    
//+------------------------------------------------------------------+
//|                             |
//| INPUT:  n              -   ;                |
//|         symbol         -  ;                            |
//|         rsi_count      -     ;|
//|         rsi_period     -               |
//| OUTPUT: true  -                       |
//|         false -                                         |
//| REMARK: no.                                                      |
//+------------------------------------------------------------------+
bool CSynchronizedBufferRSI::Init(int n,string symbol,int rsi_count,int rsi_period)
  {   
   //---   :
   m_rsi_count=rsi_count;
   m_symbol=symbol;

   //---  :
   ArraySetAsSeries(buffer,true);  //    buffer[]     
   PlotIndexSetInteger(n,PLOT_DRAW_TYPE,DRAW_LINE);   //      
   PlotIndexSetInteger(n,PLOT_LINE_STYLE,STYLE_DOT);  //    
   PlotIndexSetString (n,PLOT_LABEL,"RSI "+m_symbol); //    
        
   //---   RSI 
   if(m_handle==INVALID_HANDLE)
     {
      m_handle=iRSI(m_symbol,m_period,rsi_period,PRICE_CLOSE);
      if(m_handle==INVALID_HANDLE)
        {
         Print(__FUNCTION__," ",m_symbol,"     RSI: ", GetLastError());
         return(false);
        }
     }

   return(true);
  }

//+------------------------------------------------------------------+
//|  /  .             |
//|                                                           |
//| INPUT:  no.                                                      |
//| OUTPUT: no.                                                      |
//| REMARK: no.                                                      |
//+------------------------------------------------------------------+
void CSynchronizedBufferRSI::RefreshBuffer()
  {      
   m_init_flag=true;
   ArrayInitialize(buffer,EMPTY_VALUE); 
   for(int bar=m_rsi_count-1; bar>=0; bar--) Refresh(bar);     
   return;
  }
  
//+------------------------------------------------------------------+
//|  /          |
//|  .                                            |
//| INPUT:  bar   -                                         |
//| OUTPUT: no.                                                      |
//| REMARK: no.                                                      |
//+------------------------------------------------------------------+
void CSynchronizedBufferRSI::Refresh(int bar=0)
  {
   buffer[bar]=EMPTY_VALUE; //    .
     
   //---      :
   datetime time[1];      
   if(CopyTime(_Symbol,_Period,bar,1,time)!=1) return; //     /...

   //---    RSI         :
   double value[1];
   if(CopyBuffer(m_handle,0,time[0],time[0],value)!=1) return; //     /...

   buffer[bar]=value[0];
   return;
  }